﻿function VectorlightGame() {
    this.browser = "";
    this.deviceName = "Web";
    this.pageID = -1;
    this.appID = -1;
    this.gameWidth = 320;
    this.gameHeight = 460;
    this.userID = "";
    this.userIDDisplay = "";
    this.instanceID = "";
    this.useTouch = false;
    this.baseURL = "";
    this.rootID = "";
    this.tick = 0;
    this.splashTimer = 30;
    this.splashOpacity = 0;
    this.serviceURL;
    this.loadScrollY = 0;
    this.masUrl;
    this.wkTransPre = "translate3d(";
    this.wkTransPost = ",0)";
    this.useTimeout = false;
    this.interval = 0;
    this.intervalRef = null;
    this.gameInit = function (e, t, n, r, i) {
        this.gameInit2(e, t, n, r, i, false)
    };
    this.gameInit2 = function (e, t, n, r, i, s) {
        this.useTimeout = s;
        this.interval = i;
        if (i < 20) {
            this.splashTimer = 2 * 60
        } else {
            this.splashTimer = 2 * 30
        } if (navigator.userAgent.match(/FireFox/i) != null) {
            this.browser = "FF"
        } else {
            switch (navigator.appName) {
                case "Microsoft Internet Explorer":
                    this.browser = "IE";
                    break;
                default:
                    this.browser = "WK";
                    break
            }
        }
        this.pageID = t;
        this.deviceName = this.getDevice();
        this.rootID = e;
        this.gameWidth = n;
        this.gameHeight = r;
        if (this.deviceName != "Web") {
            this.useTouch = true
        }
        this.userID = this.dg("hidun").value;
        this.userIDDisplay = this.userID;
        if (this.userID == "") {
            this.userIDDisplay = "Guest"
        }
        this.setUrl();
        if (!this.useTimeout) {
            setInterval(this.gameTick, i)
        } else {
            setTimeout(this.gameTick, i)
        }
    };
    this.gameInit3 = function (e, t, n) {
        this.root = $("#" + e);
        this.interval = n;
        if (navigator.userAgent.match(/FireFox/i) != null) {
            this.browser = "FF"
        } else {
            switch (navigator.appName) {
                case "Microsoft Internet Explorer":
                    this.browser = "IE";
                    break;
                default:
                    this.browser = "WK";
                    break
            }
        }
        this.pageID = t;
        this.deviceName = this.getDevice();
        this.rootID = e;
        this.setSize();
        if (this.deviceName != "Web") {
            this.useTouch = true
        }
        this.userID = "";
        if (this.userID == "") {
            this.userIDDisplay = "Guest"
        }
        this.setUrl();
        this.intervalRef = setInterval(this.gameTick3, n)
    };
    this.cleanup = function () {
        clearInterval(this.intervalRef)
    };
    this.setSize = function (e, t) {
        this.gameWidth = $(window).width();
        this.gameHeight = $(window).height();
        if (e != null) {
            this.gameWidth = e
        }
        if (t != null) {
            this.gameHeight = t
        }
        this.root.attr("width", this.gameWidth);
        this.root.attr("height", this.gameHeight);
        $(".fullscreen").css("width", this.gameWidth + "px");
        $(".fullscreen").css("height", this.gameHeight + "px");
        $(".fullwidth").css("width", this.gameWidth + "px")
    };
    this.setUrl = function () {
        this.baseURL = "";
        if (window.location.hostname == "localhost") {
            this.baseURL = "http://localhost:50403/"
        } else {
            this.baseURL = "https://www.snappygames.com/"
        }
        this.serviceURL = this.baseURL + "solid.ashx";
        this.masUrl = this.baseURL + "custom-actions/Magic"
    };
    this.gameTick = function () {
        var e = true;
        thisObj = vlx;
        if (thisObj.splashTimer > 0) {
            if (thisObj.useTouch) {
                window.scrollTo(0, thisObj.loadScrollY)
            }
            thisObj.splashTimer--;
            if (thisObj.splashTimer == 0) {
                thisObj.hd("splashContainer")
            } else {
                thisObj.dg("loadingProgress").innerHTML = "Loading 100%";
                thisObj.dg("splash").style.opacity = thisObj.splashOpacity;
                thisObj.splashOpacity += .05;
                if (thisObj.splashOpacity > 1) {
                    thisObj.splashOpacity = 1;
                    thisObj.sh(thisObj.rootID)
                }
                e = false
            }
        }
        if (e) {
            gameLoop()
        }
        if (thisObj.useTimeout) {
            setTimeout(thisObj.gameTick, thisObj.interval)
        }
        this.tick++
    };
    this.gameTick3 = function () {
        gameLoop();
        this.tick++
    };
    this.pad = function (e, t) {
        var n = "" + e;
        while (n.length < t) {
            n = "0" + n
        }
        return n
    };
    this.dce = function (e, t) {
        var n = document.createElement(e);
        n.className = t;
        return n
    };
    this.dg = function (e) {
        var r = document.getElementById(e);

        if (r == null) {
            console.log("Missing element: " + e);
        }
        return r;
    };
    this.hd = function (e) {
        this.dg(e).style.display = "none"
    };
    this.sh = function (e) {
        this.dg(e).style.display = "block"
    };
    this.aTS = function (e, t) {
        this.dg(e).addEventListener("touchstart", t, false)
    };
    this.aTE = function (e, t) {
        this.dg(e).addEventListener("touchend", t, false)
    };
    this.uIP = function (e) {
        var t = (e.x | 0) + "px," + (e.y | 0) + "px";
        e.style.webkitTransform = this.wkTransPre + t + this.wkTransPost;
        e.style.MozTransform = "translate(" + t + ")";
        e.style.msTransform = e.style.MozTransform
    };
    this.getDevice = function () {
        var e = "Web";
        var t = navigator.userAgent;
        if (t.match(/iPad/i) != null) {
            e = "iPad"
        } else if (t.match(/iPod/i) != null) {
            e = "iPod"
        } else if (t.match(/iPhone/i) != null) {
            e = "iPhone"
        } else if (t.match(/Android/i) != null) {
            e = "Android";
            this.wkTransPre = "translate(";
            this.wkTransPost = ")"
        } else if (t.match(/IEMobile/i) != null) {
            e = "IEMobile"
        } else if (/Kindle/i.test(t) || /Silk/i.test(t) || /KFTT/i.test(t) || /KFOT/i.test(t) || /KFJWA/i.test(t) || /KFJWI/i.test(t) || /KFSOWI/i.test(t) || /KFTHWA/i.test(t) || /KFTHWI/i.test(t) || /KFAPWA/i.test(t) || /KFAPWI/i.test(t)) {
            e = "Kindle"
        } else if (/webOS|BlackBerry|Opera Mini/i.test(t)) {
            e = "OtherTouch"
        }
        return e
    };
    this.ArrayRemove = function (e, t) {
        var n = this.ArrayIndexOf(e, t);
        if (n >= 0) {
            e.splice(n, 1)
        }
    };
    this.ArrayContains = function (e, t) {
        if (this.ArrayIndexOf(e, t) >= 0) {
            return true
        } else {
            return false
        }
    };
    this.ArrayIndexOf = function (e, t) {
        var n = -1;
        var r;
        for (r = 0; r < e.length; r++) {
            if (e[r] == t) {
                n = r;
                break
            }
        }
        return n
    };
    this.recordHighscore = function (e, t) {
        console.log("recordHighscore");

        try {
            if (this.userID != "" && e > 0) {
                var n = e;
                var r = Math.floor(e * this.userID.length * 5 / 8);
                var i = this.serviceURL + "?ph=1&gid=" + this.pageID + "&u=" + encodeURIComponent(this.userID) + "&s=" + e + "&k=" + r + "&l=" + t;
                $.get(i, function (e, t) {
                    this.readHighscores(e)
                }, "html")
            }
        } catch (s) { }
    };
    this.recordBestTime = function (e, t) {
        console.log("recordBestTime");
        try {
            if (this.userID != "" && e > 0) {
                var n = Math.floor(e * this.userID.length * 5 / 8);
                var r = this.serviceURL + "?pt=1&gid=" + this.pageID + "&u=" + encodeURIComponent(this.userID) + "&s=" + e + "&k=" + n + "&l=" + t;
                $.get(r, function (e, t) {
                    this.readHighscores(e)
                }, "html")
            }
        } catch (i) { }
    };
    this.rG = function () {
        this.recordGamePlay()
    };
    this.recordGamePlay = function () {
        console.log("recordGamePlay");

        var t = this.getUserId();
        if (t != null) {
            var n = _aid << 3;
            $.ajax({
                type: "POST",
                url: this.masUrl,
                data: "aid=" + _aid + "&c=g&uid=" + t + "&aid=" + n,
                success: function (t) {
                    e = $(t).find("act").text()
                }
            })
        }
    };
    var e = 0;
    this.readHighscores = function (e) {
        try {
            highscores = new Array;
            $(e).find("s").each(function () {
                var e = new Highscore($(this).attr("user"), $(this).attr("score"), $(this).attr("level"));
                highscores.push(e)
            });
            drawHighscores()
        } catch (t) { }
    };
    this.readBestLevelHighscores = function (e) {
        try {
            bestLevelScores = new Array;
            $(e).find("s").each(function () {
                var e = new Highscore($(this).attr("user"), $(this).attr("score"), $(this).attr("level"));
                bestLevelScores[e.level] = e
            })
        } catch (t) { }
    };
    this.readBestUserHighscores = function (e) {
        try {
            bestUserScores = new Array;
            $(e).find("s").each(function () {
                var e = new Highscore($(this).attr("user"), $(this).attr("score"), $(this).attr("level"));
                bestUserScores[e.level] = e
            })
        } catch (t) { }
    };
    this.sA = function (e, t) {
        this.saveAchievement(e, t)
    };
    this.saveAchievement = function (t, n) {
        console.log("saveAchievement");
        var r = this.getUserId();
        var i = this.getUsername();
        if (i == null) {
            i = ""
        }
        if (r != null) {
            var s = n;//Math.floor(n * r.length * 5 / 8);
            $.ajax({
                type: "POST",
                url: this.masUrl,
                data: "aid=" + _aid + "&c=b&uid=" + r + "&tid=" + t + "&v=" + n + "&k=" + s + "&un=" + encodeURIComponent(i) + "&a=" + e
            })
        }
    };
    this.getUserId = function () {
        return window.localStorage["mas-uid"]
    };
    this.getUsername = function () {
        return window.localStorage["mas-un"]
    };
    this.getUserPic = function () {
        return window.localStorage["mas-up"]
    };
    this.setUsername = function (e) {
        window.localStorage["mas-un"] = e
    };
    this.isUserGuest = function (e) {
        if (window.localStorage["mas-t"] != null) {
            if (window.localStorage["mas-t"] >> 0 == 2) {
                return true
            }
        }
        return false
    };
    this.gA = function (e, t, n, cb) {
        this.getBestAchievement(e, t, n, cb)
    };
    this.getBestAchievement = function (e, t, n, cb) {
        console.log("getBestAchievement");
        console.log(_aid);
        $.ajax({
            type: "POST",
            url: this.masUrl,
            data: "aid=" + _aid + "&c=z&tid=" + e,
            success: function (e) {
                var r = $(e).find("un").text();
                var i = $(e).find("sc").text();
                if (t != null) {
                    document.getElementById(t).innerHTML = r
                }
                if (n != null) {
                    document.getElementById(n).innerHTML = i
                }

                if (cb) {
                    cb();
                }
            }
        })
    }

    this.setupScoreSubmitted = function () {
        $('#highscoreSubmitted .username strong').html(this.getUsername());
    }
}

function Highscore(e, t, n) {
    this.user = e;
    this.score = t;
    this.level = n
}

(function ($) {
    // duck-punching to make attr() return a map
    var _old = $.fn.attr;
    $.fn.attr = function () {
        var a, aLength, attributes, map;
        if (this[0] && arguments.length === 0) {
            map = new Array();
            attributes = this[0].attributes;
            aLength = attributes.length;
            for (a = 0; a < aLength; a++) {
                map.push(attributes[a].name);
            }
            return map;
        } else {
            return _old.apply(this, arguments);
        }
    }
}(jQuery));